
; version 2, which splits the file much differently
; so that subsegmented messages are all caught

Global $savefileopen
Global $i
Global $fileread
Global $firstsplit
Global $msgnum
Global $msgtxt
Global $msgclean
Global $fileopendialog
Global $openfileopen
Global $savefiledialog
Global $cleantext
Global $unlinebreak

; 1. User gives the source text file (HTML or TXT)

$fileopendialog = FileOpenDialog ("Select GTT source file", @ScriptDir, "All files (*.*)|Text files (*.txt)|HTML files (*.html)", 3)

$fileopendialogfileonly = StringRegExpReplace ($fileopendialog, ".+\\", "")

; 2. User gives name for output file

$filesavedialog = FileSaveDialog ("Name the output file", @ScriptDir, "All files (*.*)|Text files (*.txt)|HTML files (*.html)", 18, $fileopendialogfileonly & "_output.txt")

; 3. Script opens the two files

$openfileopen = FileOpen ($fileopendialog, 128)
$fileread = FileRead ($openfileopen)

$savefileopen = FileOpen ($filesavedialog, 130)

; 4. Split input file by message (raw)

$firstsplit = StringSplit ($fileread, '<span id="goog-gtc-unit-', 1) ; to determine number of strings

For $i = 2 to $firstsplit[0]

; 5. Get the message number ($msgnum[1])

$msgnum = StringSplit ($firstsplit[$i], '"', 1)

; 6.1 Get the raw text, step 1

If StringInStr ($firstsplit[$i], 'class="goog-gtc-translatable"') Then
$rawtext1a = StringSplit ($firstsplit[$i], 'dir="ltr">', 1)

; 6.2 Get the raw text, step 2

$rawtext1b = StringRegExpReplace ($rawtext1a[2], '(</span></span>)(\s*?)(</div>)', "$1$3") ; to remove any spaces before the div

$rawtext2 = StringSplit ($rawtext1b, '</span></span></div>', 1)

; 6.3 Convert line breaks

$rawtext3 = StringReplace ($rawtext2[1], @CRLF, '{{!LF}}')

; 6.4 Convert placeables

; 6.4.1 Move numbered placeables out of spans

If StringRegExp ($rawtext3, '(<span class="notranslate" id="ph-)(\d+)(">)') Then
$rawtext3 = StringRegExpReplace ($rawtext3, '(<span class="notranslate" id="ph-)(\d+)(">)', '<span class="notranslate">$2:')
EndIf

; 6.4.2 Convert spans to brackets

$rawtext4 = StringRegExpReplace ($rawtext3, '(<span class="notranslate">)(.+?)(</span>)', '{{$2}}')

; 6.5 Convert HTML entities

$rawtext5 = StringReplace ($rawtext4, "&#39;", "'")
$rawtext5 = StringReplace ($rawtext5, "&lt;", "<")
$rawtext5 = StringReplace ($rawtext5, "&gt;", ">")
$rawtext5 = StringReplace ($rawtext5, "&apos;", "'")
$rawtext5 = StringReplace ($rawtext5, '&quot;', '"')
$rawtext5 = StringReplace ($rawtext5, "&amp;", "&")

; 7. Grab descriptions
; Description and Placeable meaning extraction not supported
; in this version of the script because it is not necessary.

$cleantext = $rawtext5

Else
$cleantext = "!!!NO TRANSLATABLE TEXT!!!"
Endif

FileWrite ($savefileopen, $msgnum[1] & @TAB & $cleantext & @CRLF)

Next

MsgBox (0, "Done", "Did " & $i & " segments.", 0)
