
Global $alldone
Global $changeddone
Global $filereadline
Global $fileopen
Global $theendbox
Global $filereadlinesplit

#include <File.au3>
#include <Array.au3>

#cs

The three idiot2gtt scripts reads one line of translation at a time from a plaintext file and pastes the translation into Google Translate Toolkit.  Since GTT is online and has dynamically updating pages, the idiot2gtt is necessarily slow.

idiot2gtt-with-source-compare first inserts the segment's source text into the target field and then compares that source text with the source text in the plaintext file before pasting the translation.  For this reason, idiot2gtt-with-source-compare works with a tab-delimited two-column file (source text in the first column, translation in the second column).  If you have extracted the source text from GTT's frame source code, remember to convert entities back first.  In case of a mismatch, idiot2gtt-with-source-compare will paste the mismatching translation anyway, and pause.  To resume idiot2gtt-with-source-compare after it was paused, your cursor has to be in the same segment where it was paused.

idiot2gtt-with-target-compare is similar to idiot2gtt-with-source-compare, in that it compares the line from the text file with what is currently in the target segment in GTT.  The difference is that it does not first insert the source text before doing the comparison.  This may be useful if you've edited a text instead of translating it from scratch.  It works with a tab-delimited two-column file (original target text in the first column, your translation in the second column).  In case of a mismatch, idiot2gtt-with-source-compare will revert the GTT segment to its original state and pause, but the translation will still be on the clipboard, in case you want to paste it anyway.  To resume idiot2gtt-with-source-compare after it was paused, your cursor has to be in the same segment where it was paused.

idiot2gtt-inserted-blindly requires a single-column plaintext file, and it blindly replaces what is currently in GTT's target field with the translation it reads from the plaintext file.  This script is the fastest, by a small margin.  It is not recommended that you take your eyes of the screen while this script is running, because it won't stop if there is a mismatch (it doesn't *check* for mismatches).  idiot2gtt-inserted-blindly is useful for smallish jobs.

You can pause these scripts using Escape, and it is best to put your cursor back where it was when you paused it, but since there is no way of telling exactly at what point you've interrupted the process, it may happen that the first segment after you've paused it is a mismatch anyway.  So don't pause the scripts yourself unnecessarily.

#ce

HotKeySet ("{ESC}", "TheEnd")

While 1

MsgBox (0, "idiot2gtt with source compare", "Thanks for using idiot2gtt-with-source-compare. Have you read the instructions?", 0)

$fileopen = FileOpenDialog ("Select tab-delimited file with translation", "@ScriptDir", "All (*.*)|Text files (*.txt)")
FileOpen ($fileopen, 128)
$filecountlines = _FileCountLines ($fileopen)

MsgBox (0, "Click in GTT!", "Ready? Click with your mouse in the first line in GTT... you have 5 seconds!", 5)

Sleep ("5000") ; so actually you have 10 seconds...

WinWaitActive ("Translation editor", "")

$alldone = 0
$changeddone = 0

For $i = 1 to $filecountlines

WinWaitActive ("Translation editor", "")

$filereadline = FileReadLine ($fileopen, $i)

$filereadlinesplit = StringSplit ($filereadline, @TAB, 1)

If $filereadlinesplit[0] <> 2 Then
$SLterm = "!!!!!!!!!!"
$TLterm = "!!!!!!!!!!"
Else
$SLterm = $filereadlinesplit[1]
$TLterm = $filereadlinesplit[2]
Sleep ("50")
$fixedTLterm = StringReplace ($TLterm, "!!!LF!!!", @CRLF)
EndIf

Send ("^+s")
Sleep ("200")
Send ("^a")
Sleep ("100")
Send ("^x")
Sleep ("200")

$sourcetext = ClipGet()
Sleep ("50")
$fixedsourcetext = StringReplace ($sourcetext, @CRLF, "!!!LF!!!")
Sleep ("200")

If $fixedsourcetext <> $SLterm Then
ClipPut ($fixedTLterm)
Sleep ("100")
Send ("^a")
Sleep ("100")
Send ("^v")
Sleep ("200")

$mismatchq = MsgBox (4, "Mismatch!", "Is the text the same, but the placeables look different?  Say 'Yes' to attempt to fix the placeables, or say 'No' if the text is completely different." & @CRLF & @CRLF & "GSL = [" & $fixedsourcetext & "]" & @CRLF & @CRLF & "FSL = [" & $SLterm & "]" & @CRLF & @CRLF & "FTL = [" & $fixedTLterm & "]", 0) 

If $mismatchq = 6 Then

; First check if the mismatch is tag related

If NOT StringInStr ($fixedsourcetext, "{") Then

MsgBox (0, "Mismatch!", "GSL = [" & $fixedsourcetext & "]" & @CRLF & "FSL = [" & $SLterm & "]" & @CRLF & "FTL = [" & $fixedTLterm & "]", 0) 

Else

; First check if same number of tags

$sltagcount = StringReplace ($fixedsourcetext, "{", "{")
$tltagcount = StringReplace ($SLterm, "{", "{")

If $sltagcount = $tltagcount Then

; Then you can fix it

$reftext0 = $fixedsourcetext
$imptext0 = $SLterm

$reftext1 = StringReplace ($reftext0, "{", "_{")
$reftext2 = StringReplace ($reftext1, "/}", "{_")

$reftextarr = StringSplit ($reftext2, "{", 1)

$imptext1 = StringReplace ($imptext0, "{", "_{")
$imptext2 = StringReplace ($imptext1, "/}", "{_")

$imptextarr = StringSplit ($imptext2, "{", 1)

Local $output0[1]

For $mm = 1 to $imptextarr[0]

If Mod($i, 2) = 0 Then ; then its even
_ArrayAdd ($output0, $reftextarr[$mm])
Else
_ArrayAdd ($output0, $imptextarr[$mm])
EndIf

Next

$output1 = _ArrayToString($output0, "{")
$output2 = StringTrimLeft ($output1, 1)

$output3 = StringReplace ($output2, "_{", "{")
$output4 = StringReplace ($output3, "{_", "/}")

Sleep ("500")
ClipPut ($output4)
Sleep ("500")

MsgBox (0, "Fixed!", "The fixed text is on the clipboard", )

Else

MsgBox (0, "Can't fix...", "Sorry, the number of placeables are different, so I can't fix it automatically.", 0)

EndIf
EndIf
EndIf

; MsgBox (0, "Mismatch!", "GSL = " & $fixedsourcetext & @CRLF & "FSL = " & $SLterm & @CRLF & "FTL = " & $fixedTLterm, 0) 

WinActivate ("Translation editor", "")
WinWaitActive ("Translation editor", "")
Send ("^j")
Sleep ("3000")

Else
ClipPut ($fixedTLterm)
Sleep ("100")
Send ("^a")
Sleep ("100")
Send ("^v")
Sleep ("200")
Send ("^j")
Sleep ("3000")

$changeddone = $changeddone + 1
WinActivate ("Translation editor", "")

EndIf

$alldone = $alldone + 1

Next

MsgBox (0, "Done!", "Did " & $alldone & " segments, of which " & $changeddone & " changed.", 10)
Exit

WEnd

Func TheEnd()
$theendbox = MsgBox (1, "Paused...", "Did " & $alldone & " segments so far, of which " & $changeddone & " changed." & @CRLF & @CRLF & "Do you wish to continue? Click 'OK' to continue, or click 'Cancel' to exit.", 0)

If $theendbox = 2 Then
Exit
EndIf

MsgBox (0, "Click in GTT!", "Click with your mouse where you had paused... you have 5 seconds!", 5)

Sleep ("5000") ; so yes you have 10 seconds
EndFunc





